/* calcGridArea.cc
-----------------------------------
åɤѤ׻ץ
-----------------------------------
========
1. ǽ
========

ƥåɤѤ׻롣

==============================
2. ϥե롦ϥե
==============================
------------------
2.1 ϥե
-----------------

) NewGrid.dat

gcnd ϥեȤѤ˳ݤ륰åɤλͶκɸ
Ҥե롣ɸϰ޷١

-------------------------------------
2 NewChao
1 7 98.0 17.3 98.3 17.3 98.3 17.7 98.0 17.7
1 8 98.0 17.7 98.3 17.7 98.3 18.0 98.0 18.0
-----------ޤ--------------------------

------------------
2.2 ϥե
------------------

) GridArea.dat

--------
1 7 424.097094
1 8 716.863476
------ޤ--

1
  1 : åɤֹ
  2 : åɤιֹ
  3 : åɤ(km^2)
2԰ʹ
  1ԤƱ

===========
3. Ȥ
===========

(1) ʤǵư ;
   % calcGridArea
   # input file : NewGrid.dat
   # output file : GridArea.dat
   # center of the UTM zone (longitude) : 100.0

(2) Ĥǵư ;
   % calcGridArea NewGrid.dat GridArea.dat 100.0

==============
4. ѥ
==============

% make


*/

#include <stdio.h>
#include <math.h>

void ll2utm( // ޷٤ UTM ɸѴ롣
             // ڿ;(ģײ衦ĴɡС
             // ¢ʰȯ), pp. 194--196 򻲹ͤˤ
  double lambda, // ١ñ̤١
  double phi,  // ١ñ̤١
  double *ue,   //  UTM ɸñ̤ m.
  double *un,   //  UTM ɸñ̤ m.
  double cc // оݤȤ UTM Ҹ()η١㤨С
            // UTM  53 Ӥ 132 ٤ 138 ٤ϰϤǤꡢ
            // ξ cc  135 Ȥ롣 
)
{                    
  double pi, lambda0, e2, ed2, a, b, b1, b2, b3, 
    l, t2, gamma2, f, f1, f2, A, B, g, g1, g2; 
                                                  
  pi = 4.0*atan(1.0);                                                  
  e2 = 0.006674372;  /* ΥΨΣ */
  ed2 = 0.006719219; /* ΥΨΣ */ 
  a = 6377.397155;   /* ϵʱΤĹȾ(km) */
  b = 6356.078963;   /* ϵʱΤûȾ(km) */
  lambda0 = cc*pi/180.0;    /* ñ̤饸Ѵ */
  lambda = lambda*pi/180.0; /* ñ̤饸Ѵ */
  phi = phi*pi/180.0;       /* ñ̤饸Ѵ */
  A = a/sqrt(1.-e2*pow(sin(phi), 2));                                      
  b1 = 0.998329312962;                                                 
  b2 = 0.00501415801;                                                  
  b3 = 0.00001049328;                                                  
  B = a*(b1*phi-b2*sin(phi)*cos(phi)
     +b3*(sin(phi)*pow(cos(phi), 3)-pow(sin(phi), 3)*cos(phi)));
  l = lambda-lambda0;                                                      
  t2 = pow(tan(phi), 2);                                                    
  gamma2 = ed2*(pow(cos(phi), 2));                                            
  f1 = 1.0-t2+gamma2;                                                     
  f2 = 5.0-18.0*t2+pow(t2, 2)+14.0*gamma2-58.0*t2*gamma2;
  f = A*l*cos(phi)*(1.0+1.0/6.0*pow(l, 2)*pow(cos(phi), 2)
		    *(f1+1.0/20.0*pow(l, 2)*pow(cos(phi), 2)*f2));
  g1 = 5.0-t2+9.0*gamma2+4.0*pow(gamma2, 2);
  g2 = 61.0-58.0*t2+pow(t2, 2)+270.0*gamma2-330.0*t2*gamma2;
  g = B+0.5*A*pow(l, 2)*sin(phi)*cos(phi)
      *(1.0+1.0/12.0*pow(l, 2)*pow(cos(phi), 2)
      *(g1+1.0/30.0*pow(l, 2)*pow(cos(phi), 2)*g2));
  *ue = (0.9996*f+500.0)*1000.0;
  *un = (0.9996*g)*1000.0;
}

int main(int argc, char** argv)
{
  // οΥå
  if (argc != 1 && argc != 4) {
    printf("Usage : calcGridArea inputFileName outputFileName cc\n");
    exit(1);
  }

  char input_fname[256];           // ϥե̾
  char output_fname[256];          // ϥե̾
  double cc;                       // UTMҸ()η

  if (argc == 1) {
    printf("# input file : ");
    scanf("%s", input_fname);
    printf("# output file : ");
    scanf("%s", output_fname);
    printf("# center of the UTM zone (longitude) : ");
    scanf("%lf", &cc);
  }

  else {
    sscanf(argv[1], "%s", input_fname);
    sscanf(argv[2], "%s", output_fname);
    sscanf(argv[3], "%lf", &cc);
  }

  FILE* fp_in;
  FILE* fp_out;

  int xMap, yMap;              // åɥܥåֹ
  double lon[4], lat[4];       // Ͷΰ޷ٺɸ
  double utmx[4], utmy[4];     // ͶUTMɸ
  double L0, L1, L2, L3, L4; 
  double s, gridArea;
  char buf[256];
  int i;
  double areaSum = 0.;

  if((fp_in = fopen(input_fname, "r")) == NULL){
    printf("Cannot open input file.\n");
    exit(1);
  }

  fp_out = fopen(output_fname, "w");

  fprintf(fp_out, "# %s\n\n", output_fname);

  while(fgets(buf, 256, fp_in) != NULL){
    if((buf[0] == '#') || (buf[0] == '\n')) continue;
    if((sscanf(buf, "%d %d %lf %lf %lf %lf %lf %lf %lf %lf",
	       &xMap, &yMap, &lon[0], &lat[0], &lon[1], &lat[1],
	       &lon[2], &lat[2], &lon[3], &lat[3])) == 10){
      for(i = 0; i < 4; i++){
	ll2utm(lon[i], lat[i], &utmx[i], &utmy[i], cc);
      }

      L0 = sqrt(pow(fabs(utmx[1] - utmx[0]), 2) 
		+ pow(fabs(utmy[1] - utmy[0]), 2));
      L1 = sqrt(pow(fabs(utmx[2] - utmx[1]), 2)
		+ pow(fabs(utmy[2] - utmy[1]), 2));
      L2 = sqrt(pow(fabs(utmx[3] - utmx[2]), 2)
		+ pow(fabs(utmy[3] - utmy[2]), 2));
      L3 = sqrt(pow(fabs(utmx[0] - utmx[3]), 2)
		+ pow(fabs(utmy[0] - utmy[3]), 2));
      L4 = sqrt(pow(fabs(utmx[2] - utmx[0]), 2)
		+ pow(fabs(utmy[2] - utmy[0]), 2));

      // إθѤƥåɤѤ롣
      
      s = (L0 + L1 + L4)/2;
      gridArea = sqrt(s*(s - L0)*(s - L1)*(s - L4));
      
      s = (L2 + L3 + L4)/2;
      gridArea += sqrt(s*(s - L2)*(s - L3)*(s - L4));
      
      areaSum += gridArea*pow(10, -6);

      printf("%d %d gridArea = %f (km^2)\n", 
	     xMap, yMap, gridArea*pow(10, -6));
		       
      fprintf(fp_out, "%d %d %f\n", 
	     xMap, yMap, gridArea*pow(10, -6));		       
      

    }
  }

  fclose(fp_in);
  fclose(fp_out);

  printf("areaSum = %f\n", areaSum);

  return 0;
}
